using System;

class Counter
{
	private long count;
	private long increment;

	public Counter(long start, long increment)
	{
		count = start;
		this.increment = increment;
	}

	public void Increment()
	{
		count += increment;
	}

	public long GetValue()
	{
		return count;
	}
}


class UseCounter
{
	private Counter counter;

	public UseCounter(Counter counter)
	{
		this.counter = counter;
	}

	public void Increment()
	{
		counter.Increment();
	}

	public long GetValue()
	{
		return counter.GetValue();
	}
}

class Example
{
	static void Main()
	{
		Counter counter = new Counter(0, 1);
		UseCounter useCounter = new UseCounter(counter);

		useCounter.Increment();
		useCounter.Increment();

		UseCounter useCounter2 = new UseCounter(counter);
		useCounter2.Increment();

		Console.WriteLine("Counter value = {0}", useCounter.GetValue());
		Console.WriteLine("Counter value = {0}", useCounter2.GetValue());
	}

}