using System;
using System.Runtime.Remoting;

[Serializable]
class Counter
{
	private long count;
	private long increment;

	public Counter(long start, long increment)
	{
		Console.WriteLine("Counter constructor AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		count = start;
		this.increment = increment;
	}

	public void Increment()
	{
		Console.WriteLine("Counter Increment AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		count += increment;
	}

	public long GetValue()
	{
		Console.WriteLine("Counter GetValue AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		return count;
	}
}

[Serializable]
class UseCounter
{
	private Counter counter;

	public UseCounter(Counter counter)
	{
		Console.WriteLine("UseCounter constructor AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		Console.WriteLine("Is counter a proxy? {0}", RemotingServices.IsTransparentProxy(counter));
		this.counter = counter;
	}

	public void Increment()
	{
		Console.WriteLine("UseCounter Increment AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		counter.Increment();
	}

	public long GetValue()
	{
		Console.WriteLine("UseCounter GetValue AppDomain:{0}", AppDomain.CurrentDomain.FriendlyName);
		return counter.GetValue();
	}
}

class Example
{
	static void Main()
	{
		Counter counter = new Counter(0, 1);

		AppDomain appDomain = AppDomain.CreateDomain("NewDomain");
		object[] args = new Object[1];
		args[0] = counter;

		ObjectHandle oh = appDomain.CreateInstance("CodeIsolation", "UseCounter", false, 0, null, args, null, null, null);
		Console.WriteLine("Is handle an proxy? {0}", RemotingServices.IsTransparentProxy(oh));
		UseCounter useCounter = (UseCounter)oh.Unwrap();
		Console.WriteLine("Is object an proxy? {0}", RemotingServices.IsTransparentProxy(useCounter));

		useCounter.Increment();
		useCounter.Increment();

		AppDomain appDomain2 = AppDomain.CreateDomain("NewDomain2");
		oh = appDomain2.CreateInstance("CodeIsolation", "UseCounter", false, 0, null, args, null, null, null);
		UseCounter useCounter2 = (UseCounter)oh.Unwrap();

		useCounter2.Increment();

		Console.WriteLine("Counter value = {0}", useCounter.GetValue());
		Console.WriteLine("Counter value = {0}", useCounter2.GetValue());
	}
}