using System;
using System.Reflection;
using System.Threading;
using System.Xml;

public class ManagedHost
{
	public int StartManagedHost()
	{
		Console.WriteLine("Managed Host started on Thread {0}...", Thread.CurrentThread.GetHashCode());

		XmlTextReader reader = null;

		try
		{
			reader = new XmlTextReader (@"..\bin\AppsToRun.xml");
			while (reader.Read())
			{
				switch (reader.NodeType)
				{
					case XmlNodeType.Element:
						if (reader.Name == "App")
						{
							reader.Read();
							string app = reader.Value.Trim();

							NewApp newApp = new NewApp(app);
							ThreadStart newThread = new ThreadStart(newApp.RunUserCode);
							Thread thread = new Thread(newThread);
							thread.Start();
							Interlocked.Increment(ref AppCounter.appCounter);
						}
						break;
					default:
						break;
				}
			}			
		}
		catch (Exception e)
		{
			Console.WriteLine ("Exception: {0}", e.Message);
		}

		finally
		{
			if (reader != null)
				reader.Close();

			while (AppCounter.appCounter != 0)
				Thread.Sleep(1000);
		}
	
		return 100;
	}
}

internal class AppCounter
{
	public static int appCounter = 0;
}

internal class NewApp
{
	string appName;

	public NewApp(string appName)
	{
		this.appName = appName;
	}

	public void RunUserCode()
	{
		int val = -1;
		try
		{
			AppDomain newDomain = AppDomain.CreateDomain(appName);
			Console.WriteLine("Domain {0} running on Thread {1}", appName, Thread.CurrentThread.GetHashCode());
					
			string assemblyName = @"..\bin\" + appName;
			val = newDomain.ExecuteAssembly(assemblyName);
			Console.WriteLine("Application {0} returned value {1}", appName, val);
		}
		catch (Exception e)
		{
			Console.WriteLine("Exception: " + e.Message);
		}
		finally
		{
			Interlocked.Decrement(ref AppCounter.appCounter);
		}
		return;
	}
}

